drop table if exists ArtistAlbum;
drop table if exists Artist; 
drop table if exists Track; 
drop table if exists Album; 
drop table if exists Format; 


CREATE TABLE Format (  
   id BIGINT PRIMARY KEY 
  ,name CHAR(20) NOT NULL UNIQUE
  ,format SMALLINT NOT NULL
);

CREATE TABLE Album (  
   id BIGINT PRIMARY KEY 
  ,name CHAR(20) NOT NULL UNIQUE
);

CREATE TABLE Track (  
   name CHAR(20) NOT NULL UNIQUE
  ,album BIGINT NOT NULL REFERENCES Album
    ON DELETE CASCADE
  ,UNIQUE (name, album)
  ,format SMALLINT NOT NULL
  ,CHECK (format in (1,2,3)) -- Mp3, Flac, Mp4
);

CREATE TABLE Artist (  
   id BIGINT PRIMARY KEY 
  ,name CHAR(20) NOT NULL
  ,surname CHAR(20) NOT NULL
  ,sex SMALLINT NOT NULL
  ,CHECK (sex in (1,2))  -- female, male --
);

CREATE TABLE ArtistAlbum (  
   artist BIGINT NOT NULL REFERENCES Artist
  ,album BIGINT NOT NULL REFERENCES Album
  ,PRIMARY KEY(artist, album)
  ,name CHAR(20) NOT NULL UNIQUE
  ,isLead BOOLEAN NOT NULL
);



